#include <stdio.h>

int main(){
    int N,Q,i,j,s;
    scanf("%d %d",&N,&Q);

    int d[N],p[N];
    
    for(i=0;i<N;i++){
        scanf("%d %d",&d[i],&p[i]);
    }
    
    int k[Q];
    for(i=0;i<Q;i++){
        scanf("%d",&k[i]);
    }
    
    int total[Q],ima,ukup;
    
    for(i=0;i<Q;i++){
    	s=0;
    	ima=0;
    	ukup=0;
    	
        for(j=1;j<=k[i];j++){
        	
        	if(d[s]==j){
        		ima+=p[s];
        		s++;
			}
			
            if(ima>0){
                ima--;
                ukup++;
            }
        }
        
        printf("%d\n",ukup);
    }
    
    return 0;
}